/*	color.c
*/

#include "tik.h"

#define	SHL12(X)	((X) * 4096)	/* as an int, << 12 */
#define	SHR12(X)	((X) / 4096)	/* as an int, >> 12 */

uint8
chdk_yuv2r(register double y, register double u, register double v)
{
	register double t = SHR12(SHL12(y) + (v * 5743) + 2048);
	return((t < 0) ? 0 : ((t > 255) ? 255 : ((uint8 ) (t + 0.5))));
}

uint8
chdk_yuv2g(register double y, register double u, register double v)
{
	register double t = SHR12(SHL12(y) - (u * 1411) - (v * 2925) + 2048);
	return((t < 0) ? 0 : ((t > 255) ? 255 : ((uint8 ) (t + 0.5))));
}

uint8
chdk_yuv2b(register double y, register double u, register double v)
{
	register double t = SHR12(SHL12(y) + (u * 7258) + 2048);
	return((t < 0) ? 0 : ((t > 255) ? 255 : ((uint8 ) (t + 0.5))));
}
