/*	reader.h
*/

#include <sys/ioctl.h>

typedef enum {
	wavePNM, waveGRAY, waveRGB, waveUYVYYY, waveUYVYYYold, waveNOISE
} wavetype_t;

typedef struct {
	wavetype_t	typ;	/* Type of wave */
	uint32	c;		/* Colors per pixel */
	uint32	v;		/* Version */
	uint32	z;		/* Z dimension -- maximum sample value */
	uint32	x;		/* X dimension (in samples) */
	uint32	y;		/* Y dimension */
	int64	b;		/* Begin time (in ns) -- can overflow 32-bit ints! */
	uint32	f;		/* Frame duration (in ns) */
	uint32	t;		/* Shutter duration (in ns) */
	uint32	r;		/* Rolling shutter duration (in ns) */
	uint32	rx;		/* Rolling shutter X divisor */
	uint32	ry;		/* Rolling shutter Y divisor */
	uint32	g;		/* Gamma (* 1000000) */
	uint32	s;		/* Size of wave file (in bytes) */
} wave_t;

extern	wave_t	waveref;
extern	wave_t	wavework;
extern	wave_t	*wavep;

#define	wavetype	(wavep->typ)
#define	wavec		(wavep->c)
#define	wavev		(wavep->v)
#define	wavez		(wavep->z)
#define	wavex		(wavep->x)
#define	wavey		(wavep->y)
#define	waveb		(wavep->b)
#define	wavef		(wavep->f)
#define	wavet		(wavep->t)
#define	waver		(wavep->r)
#define	waverx		(wavep->rx)
#define	wavery		(wavep->ry)
#define	waveg		(wavep->g)
#define	waves		(wavep->s)

extern	int	PNMnextc(void);
extern	uint32	PNMnextw(void);
extern	int	PNMnextcfast(void);
extern	uint8	*PNMnextbn(uint8 *buf, int count);
extern	uint8	*PNMreader();
extern	uint8	*P5reader();
extern	uint8	*P6reader();
extern	void	start_ffmpeg(char *filename);
extern	void	stop_ffmpeg(void);

extern	int	PNMfd;
extern	uint8	PNMc;
extern	uint32	PNMw;
extern	int	PNMx;
extern	int	PNMy;
extern	int	PNMmaxval;
extern	uint8	*PNMimage;
extern	int	PNMtimedout;

